package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLUnionPWMultiAff_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLUnionPWMultiAff extends JNIObject implements IISLStandardMethods {
	
	/* @generated */
	protected ISLUnionPWMultiAff(long ptr) {
		/*** PROTECTED REGION ID(ISLUnionPWMultiAff_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLUnionPWMultiAff build(long ptr) {
		return new ISLUnionPWMultiAff(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLUnionPWMultiAff_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_union_pw_multi_aff_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLUnionPWMultiAff buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_multi_aff_read_from_str) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLUnionPWMultiAff buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_multi_aff_empty) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_from_domain 
	 * 
	@take uset
	 * @generated
	**/
	 public static ISLUnionPWMultiAff buildFromDomain(ISLUnionSet uset) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_multi_aff_from_domain) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(uset);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_from_domain(getNativePtr(uset)));
			} finally {
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_multi_val_on_domain 
	 * 
	@take domain mv
	 * @generated
	**/
	 public static ISLUnionPWMultiAff buildMultiValOnDomain(ISLUnionSet domain, ISLMultiVal mv) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_multi_aff_multi_val_on_domain) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(domain, mv);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_multi_val_on_domain(getNativePtr(domain), getNativePtr(mv)));
			} finally {
				taken(domain);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLUnionPWMultiAff upma, int format) { 
		/*** PROTECTED REGION ID(static_isl_union_pw_multi_aff_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_multi_aff_to_string(getNativePtr(upma), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_union_map_from_union_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionMap toUnionMap() {
		/*** PROTECTED REGION ID(isl_union_map_from_union_pw_multi_aff) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionMap.build(ISLNative.isl_union_map_from_union_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_multi_union_pw_aff_from_union_pw_multi_aff 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLMultiUnionPWAff toMultiUnionPWAff() {
		/*** PROTECTED REGION ID(isl_multi_union_pw_aff_from_union_pw_multi_aff) DISABLED START ***/
		ISLMultiUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLMultiUnionPWAff.build(ISLNative.isl_multi_union_pw_aff_from_union_pw_multi_aff(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_get_union_pw_aff 
	 * 
	 * @generated
	**/
	public ISLUnionPWAff getUnionPWAff(int pos) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_get_union_pw_aff) DISABLED START ***/
		ISLUnionPWAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWAff.build(ISLNative.isl_union_pw_multi_aff_get_union_pw_aff(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_union_pw_multi_aff_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_union_pw_multi_aff_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_copy 
	 * 
	 * @generated
	**/
	public ISLUnionPWMultiAff copy() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_copy) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_union_pw_multi_aff_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_multi_aff_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_n_pw_multi_aff 
	 * 
	 * @generated
	**/
	public int getNbPWMultiAffs() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_n_pw_multi_aff) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_multi_aff_n_pw_multi_aff(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_set_dim_name) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_find_dim_by_name 
	 * 
	 * @generated
	**/
	public int findByDimName(ISLDimType type, String name) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_find_dim_by_name) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_multi_aff_find_dim_by_name(getNativePtr(this), type.getValue(), name);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_reset_user 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff resetUser() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_reset_user) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_reset_user(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_extract_pw_multi_aff 
	 * 
	 * @take space
	 * @generated
	**/
	public ISLPWMultiAff extractPWMultiAff(ISLSpace space) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_extract_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_extract_pw_multi_aff(getNativePtr(this), getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_get_pw_multi_aff_list 
	 * 
	 * @generated
	**/
	public ISLPWMultiAffList getPWMultiAffList() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_get_pw_multi_aff_list) DISABLED START ***/
		ISLPWMultiAffList res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLPWMultiAffList.build(ISLNative.isl_union_pw_multi_aff_get_pw_multi_aff_list(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_add_pw_multi_aff 
	 * 
	 * @take this pma
	 * @generated
	**/
	public ISLUnionPWMultiAff add(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_add_pw_multi_aff) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, pma);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_add_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(this);
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_add 
	 * 
	 * @take this upma2
	 * @generated
	**/
	public ISLUnionPWMultiAff add(ISLUnionPWMultiAff upma2) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_add) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upma2);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_add(getNativePtr(this), getNativePtr(upma2)));
			} finally {
				taken(this);
				taken(upma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_sub 
	 * 
	 * @take this upma2
	 * @generated
	**/
	public ISLUnionPWMultiAff sub(ISLUnionPWMultiAff upma2) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_sub) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upma2);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_sub(getNativePtr(this), getNativePtr(upma2)));
			} finally {
				taken(this);
				taken(upma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_union_add 
	 * 
	 * @take this upma2
	 * @generated
	**/
	public ISLUnionPWMultiAff unionAdd(ISLUnionPWMultiAff upma2) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_union_add) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upma2);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_union_add(getNativePtr(this), getNativePtr(upma2)));
			} finally {
				taken(this);
				taken(upma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_scale_val 
	 * 
	 * @take this val
	 * @generated
	**/
	public ISLUnionPWMultiAff scale(ISLVal val) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_scale_val) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, val);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_scale_val(getNativePtr(this), getNativePtr(val)));
			} finally {
				taken(this);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_scale_down_val 
	 * 
	 * @take this val
	 * @generated
	**/
	public ISLUnionPWMultiAff scaleDown(ISLVal val) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_scale_down_val) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, val);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_scale_down_val(getNativePtr(this), getNativePtr(val)));
			} finally {
				taken(this);
				taken(val);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_scale_multi_val 
	 * 
	 * @take this mv
	 * @generated
	**/
	public ISLUnionPWMultiAff scale(ISLMultiVal mv) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_scale_multi_val) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, mv);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_scale_multi_val(getNativePtr(this), getNativePtr(mv)));
			} finally {
				taken(this);
				taken(mv);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_neg 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff neg() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_neg) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_neg(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_involves_nan 
	 * 
	 * @generated
	**/
	public boolean involvesNaN() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_involves_nan) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_multi_aff_involves_nan(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLUnionPWMultiAff upma2) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_union_pw_multi_aff_plain_is_equal(getNativePtr(this), getNativePtr(upma2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_domain 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet domain() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_domain) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_pw_multi_aff_domain(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_coalesce 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff coalesce() {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_coalesce) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_coalesce(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLUnionPWMultiAff alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_align_params) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_drop_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionPWMultiAff dropDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_drop_dims) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_drop_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_intersect_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWMultiAff intersectDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_intersect_domain) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_intersect_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_intersect_params 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLUnionPWMultiAff intersectParams(ISLSet set) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_intersect_params) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_intersect_params(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_intersect_domain_wrapped_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWMultiAff intersectDomainWrappedDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_intersect_domain_wrapped_domain) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_intersect_domain_wrapped_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_intersect_domain_wrapped_range 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWMultiAff intersectDomainWrappedRange(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_intersect_domain_wrapped_range) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_intersect_domain_wrapped_range(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_subtract_domain 
	 * 
	 * @take this uset
	 * @generated
	**/
	public ISLUnionPWMultiAff subtractDomain(ISLUnionSet uset) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_subtract_domain) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, uset);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_subtract_domain(getNativePtr(this), getNativePtr(uset)));
			} finally {
				taken(this);
				taken(uset);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_pullback_union_pw_multi_aff 
	 * 
	 * @take this upma2
	 * @generated
	**/
	public ISLUnionPWMultiAff pullback(ISLUnionPWMultiAff upma2) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_pullback_union_pw_multi_aff) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upma2);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_pullback_union_pw_multi_aff(getNativePtr(this), getNativePtr(upma2)));
			} finally {
				taken(this);
				taken(upma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_flat_range_product 
	 * 
	 * @take this upma2
	 * @generated
	**/
	public ISLUnionPWMultiAff flatRangeProduct(ISLUnionPWMultiAff upma2) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_flat_range_product) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, upma2);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_flat_range_product(getNativePtr(this), getNativePtr(upma2)));
			} finally {
				taken(this);
				taken(upma2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_gist_params 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionPWMultiAff gistParams(ISLSet context) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_gist_params) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_gist_params(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_pw_multi_aff_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLUnionPWMultiAff gist(ISLUnionSet context) {
		/*** PROTECTED REGION ID(isl_union_pw_multi_aff_gist) DISABLED START ***/
		ISLUnionPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLUnionPWMultiAff.build(ISLNative.isl_union_pw_multi_aff_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLUnionPWMultiAff_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
